--## WCFilter - Window.lua written by Burgus ##--
-- set vars
local left, top, width, spaces, font, fontb, fontsb, fontl, alignML, alignMC, alignLC, alignTL, alignTR, logo, line = 10, 10, 294, "  ", Turbine.UI.Lotro.Font.Verdana12, Turbine.UI.Lotro.Font.Verdana14, Turbine.UI.Lotro.Font.TrajanPro14, Turbine.UI.Lotro.Font.TrajanProBold16, Turbine.UI.ContentAlignment.MiddleLeft, Turbine.UI.ContentAlignment.MiddleCenter, Turbine.UI.ContentAlignment.LeftCenter, Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.ContentAlignment.TopRight, "Burgus/WCFilter/Resources/wcf_small.tga";
local UIlabel, UIcheckbox, UItextbox, UILtextbox, UILbutton, UILGbutton, UILscrollbar, UIOvert, UIControl, UIOutline = Turbine.UI.Label, Turbine.UI.Lotro.CheckBox, Turbine.UI.TextBox, Turbine.UI.Lotro.TextBox, Turbine.UI.Lotro.Button, Turbine.UI.Lotro.GoldButton, Turbine.UI.Lotro.ScrollBar, Turbine.UI.Orientation.Vertical, Turbine.UI.Control, Turbine.UI.FontStyle.Outline;
--## Functions for drawing the options panel ##--
-- function for adding lines
local function add_h_line(top,double)
	local line, lheight = UIControl(), 1;
	line:SetParent(oP);
	if (double == true) then
		top = top + 28
		lheight = 3
	else
		top = top + 24
	end;
	line:SetPosition(0, top);
	line:SetSize(width + (left * 2), lheight);
	line:SetBackColor(color(41/255, 48/255, 72/255));
	return top + 8;
end;
-- get optionspanel
oP = Turbine.UI.Control();
function GetOptionsPanel()
	--## WCFilter Label ##--
	-- draw background	
	oP.backg = UIlabel();
	oP.backg:SetParent(oP);
	oP.backg:SetPosition(0, 0);
	oP.backg:SetSize(width + (left * 2), 1);
	oP.backg:SetBackColor(color(0, 0, 0.12));
	-- draw left line
	oP.lline = UIControl();
	oP.lline:SetParent(oP);
	oP.lline:SetPosition(0, 0);
	oP.lline:SetSize(3, 1);
	oP.lline:SetBackColor(color(41/255, 48/255, 72/255));
	oP.lline:SetZOrder(50)
	-- draw right line
	oP.rline = UIControl();
	oP.rline:SetParent(oP);
	oP.rline:SetPosition(width + (left * 2), 0);
	oP.rline:SetSize(3, 1);
	oP.rline:SetBackColor(color(41/255, 48/255, 72/255));
	oP.rline:SetZOrder(51)
	-- draw top line
	line = UIControl();
	line:SetParent(oP);
	line:SetPosition(0, 0);
	line:SetSize(width + (left * 2), 3);
	line:SetBackColor(color(41/255, 48/255, 72/255));
	top = top + 3
	-- Background
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(0, 4);
	label:SetSize(width + 20, 36);
	label:SetBackColor(color(0.1, 0.1, 0.3));
	-- Icon
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left + 2, top - 2);
	label:SetSize(20, 21);
	label:SetBackground(logo);
	-- Labeltext
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left + 34, top - 7);
	label:SetSize(width - 64, 24);
	label:SetText(WCFLangData.oplabel);
	label:SetFont(fontl);
	label:SetTextAlignment(alignML);
	label:SetForeColor(color(0, 1, 0));
	label:SetMarkupEnabled(true);
	label:SetOutlineColor(color(0, 0, 0.6));
	label:SetFontStyle(UIOutline);
	-- Author
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left + 30, top + 12);
	label:SetSize(110, 12);
	label:SetForeColor(color(0.6, 0.6, 1));
	label:SetText(WCFLangData.by.."Burgus");
	label:SetFont(font);
	label:SetTextAlignment(alignML);
	-- Version
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(width - 38, top + 11);
	label:SetFont(font);
	label:SetSize(42, 10);
	label:SetText("v "..version);
	label:SetForeColor(color(0.4, 0.4, 1));
	label:SetTextAlignment(alignTR);
	-- Help-Button
	hbutton = Turbine.UI.Button();
	hbutton:SetParent(oP);
	hbutton:SetPosition(width - 28, top - 5);
	hbutton:SetSize(32, 12);
	hbutton:SetForeColor(color(0.6, 0.6, 1));
	hbutton:SetTextAlignment(alignTR);
	hbutton:SetEnabled(true);
	hbutton.Click = function() GetHelpWindow(); end;
	hbutton.MouseEnter = function() hbutton:SetForeColor(color(0.8, 0.8, 1)); end;
	hbutton.MouseLeave = function() hbutton:SetForeColor(color(0.6, 0.6, 1)); end;
	hbutton:SetFont(font);
	hbutton:SetText(WCFLangData.help);

	--## Misc Settings ##--
	top = add_h_line(top ,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(0, top - 3);
	label:SetSize(width + 20, 30);
	label:SetBackColor(color(0.1, 0.1, 0.3));
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top + 3);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.icmlabel);
	label:SetTextAlignment(alignMC);
	-- Pause temporarily (off) --
	top = add_h_line(top,true);
	if (not oP.pause) then
		oP.pause = UIcheckbox();
		oP.pause:SetParent(oP);
		oP.pause:SetSize(width, 18);
		oP.pause:SetPosition(left, top + 1);
		oP.pause:SetFont(font);
		oP.pause:SetChecked(false);
		oP.pause:SetMarkupEnabled(true);
		oP.pause:SetCheckAlignment(alignML);
		oP.pause:SetText(spaces..wcol1..WCFLangData.pausetxt..wcol0);
		oP.pause.CheckedChanged = function(box)
			state = box:IsChecked();
			if (state == true) then fstate,cstate = false,true; oP.qpause:SetChecked(false); else fstate = true; end;
		end
	end
	-- Pause temporarily (quiet) --
	top = add_h_line(top);
	if (not oP.qpause) then
		oP.qpause = UIcheckbox();
		oP.qpause:SetParent(oP);
		oP.qpause:SetSize(width, 18);
		oP.qpause:SetPosition(left, top + 1);
		oP.qpause:SetFont(font);
		oP.qpause:SetChecked(false);
		oP.qpause:SetMarkupEnabled(true);
		oP.qpause:SetCheckAlignment(alignML);
		oP.qpause:SetText(spaces..wcol1..WCFLangData.qpausetxt..wcol0);
		oP.qpause.CheckedChanged = function(box)
			state = box:IsChecked();
			if (state == true) then cstate,fstate = false,true; oP.pause:SetChecked(false); else cstate = true; end;
			getQStates(cstate);
		end
	end
	-- Avatar --
	top = add_h_line(top);
	if (not oP.icon) then
		oP.icon = UIcheckbox();
		oP.icon:SetParent(oP);
		oP.icon:SetSize(width, 18);
		oP.icon:SetPosition(left, top + 1);
		oP.icon:SetFont(font);
		oP.icon:SetMarkupEnabled(true);
		oP.icon:SetCheckAlignment(alignML);
		oP.icon:SetText(spaces..wcol1..WCFLangData.icontxt..wcol0);
		oP.icon.CheckedChanged = function(box)
			settings.icon = box:IsChecked();
			if (settings.icon == true) then GetOptWindow(); elseif (WCFWin) then WCFWin:Close(); end;
			DoCallbacks(oP, SChng);
		end
	end
	-- Pause in Instances --
	top = add_h_line(top);
	if (not oP.inini) then
		oP.inini = UIcheckbox();
		oP.inini:SetParent(oP);
		oP.inini:SetSize(width, 18);
		oP.inini:SetPosition(left, top + 1);
		oP.inini:SetFont(font);
		oP.inini:SetMarkupEnabled(true);
		oP.inini:SetCheckAlignment(alignML);
		oP.inini:SetText(spaces..wcol1..WCFLangData.ininitxt..wcol0);
		oP.inini.CheckedChanged = function(box)
			settings.inini = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	-- Pause in Combat --
	top = add_h_line(top);
	if (not oP.icombat) then
		oP.icombat = UIcheckbox();
		oP.icombat:SetParent(oP);
		oP.icombat:SetSize(width, 18);
		oP.icombat:SetPosition(left, top + 1);
		oP.icombat:SetFont(font);
		oP.icombat:SetMarkupEnabled(true);
		oP.icombat:SetCheckAlignment(alignML);
		oP.icombat:SetText(spaces..wcol1..WCFLangData.icombattxt..wcol0);
		oP.icombat.CheckedChanged = function(box)
			settings.icombat = box:IsChecked();
			if (settings.icombat == true) then AddCallback(player, ctmp, checkCombat); else RemoveCallback(player, ctmp, checkCombat); end;
			DoCallbacks(oP, SChng);
		end
	end

	--## build-in filters ##--
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(0, top - 3);
	label:SetSize(width + 20, 30);
	label:SetBackColor(color(0.1, 0.1, 0.3));
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top + 3);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.mainlabel);
	label:SetTextAlignment(alignMC);
	-- Invert --
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(0, top - 3);
	label:SetSize(width + 20, 30);
	label:SetBackColor(color(0.0, 0.1, 0.3));
	if (not oP.invert) then
		oP.invert = UIcheckbox();
		oP.invert:SetParent(oP);
		oP.invert:SetSize(width, 18);
		oP.invert:SetPosition(left, top + 2);
		oP.invert:SetFont(font);
		oP.invert:SetMarkupEnabled(true);
		oP.invert:SetBackColor(color(0.2, 0.2, 0.2));
		oP.invert:SetForeColor(color(0.6, 0.7, 1.0))
		oP.invert:SetCheckAlignment(alignML);
		oP.invert:SetText(spaces..WCFLangData.inverttxt);
		oP.invert.CheckedChanged = function(box)
			settings.invert = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	-- Sell --
	top = add_h_line(top,true);
	if (not oP.sell) then
		oP.sell = UIcheckbox();
		oP.sell:SetParent(oP);
		oP.sell:SetSize(width, 18);
		oP.sell:SetPosition(left, top);
		oP.sell:SetFont(font);
		oP.sell:SetCheckAlignment(alignML);
		oP.sell:SetText(spaces..WCFLangData.sell);
		oP.sell.CheckedChanged = function(box)
			settings.sell = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	-- Give --
	top = add_h_line(top);
	if (not oP.give) then
		oP.give = UIcheckbox();
		oP.give:SetParent(oP);
		oP.give:SetSize(width, 16);
		oP.give:SetPosition(left, top);
		oP.give:SetFont(font);
		oP.give:SetCheckAlignment(alignML);
		oP.give:SetText(spaces..WCFLangData.give);
		oP.give.CheckedChanged = function(box)
			settings.give = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	-- Valar --
	top = add_h_line(top);	
	if (not oP.valar) then
		oP.valar = UIcheckbox();
		oP.valar:SetParent(oP);
		oP.valar:SetSize(width, 16);
		oP.valar:SetPosition(left, top);
		oP.valar:SetFont(font);
		oP.valar:SetCheckAlignment(alignML);
		oP.valar:SetText(spaces..WCFLangData.valartxt);
		oP.valar.CheckedChanged = function(box)
			settings.valar = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	-- Buy --
	top = add_h_line(top);	
	if (not oP.buy) then
		oP.buy = UIcheckbox();
		oP.buy:SetParent(oP);
		oP.buy:SetSize(width, 16);
		oP.buy:SetPosition(left, top);
		oP.buy:SetFont(font);
		oP.buy:SetCheckAlignment(alignML);
		oP.buy:SetText(spaces..WCFLangData.buy);
		oP.buy.CheckedChanged = function(box)
			settings.buy = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	-- Search --
	top = add_h_line(top);	
	if (not oP.search) then
		oP.search = UIcheckbox();
		oP.search:SetParent(oP);
		oP.search:SetSize(width, 16);
		oP.search:SetPosition(left, top);
		oP.search:SetFont(font);
		oP.search:SetCheckAlignment(alignML);
		oP.search:SetText(spaces..WCFLangData.search);
		oP.search.CheckedChanged = function(box)
			settings.search = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	-- Exchange --
	top = add_h_line(top);
	if (not oP.exchange) then	
		oP.exchange = UIcheckbox();
		oP.exchange:SetParent(oP);
		oP.exchange:SetSize(width, 16);
		oP.exchange:SetPosition(left, top);
		oP.exchange:SetFont(font);
		oP.exchange:SetCheckAlignment(alignML);
		oP.exchange:SetText(spaces..WCFLangData.exchange);
		oP.exchange.CheckedChanged = function(box)
			settings.exchange = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	-- Group --
	top = add_h_line(top);
	if (not oP.group) then	
		oP.group = UIcheckbox();
		oP.group:SetParent(oP);
		oP.group:SetSize(width, 16);
		oP.group:SetPosition(left, top);
		oP.group:SetFont(font);
		oP.group:SetCheckAlignment(alignML);
		oP.group:SetText(spaces..WCFLangData.grouptxt);
		oP.group.CheckedChanged = function(box)
			settings.group = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	-- Kinship --
	top = add_h_line(top);
	if (not oP.kinship) then	
		oP.kinship = UIcheckbox();
		oP.kinship:SetParent(oP);
		oP.kinship:SetSize(width, 16);
		oP.kinship:SetPosition(left, top);
		oP.kinship:SetFont(font);
		oP.kinship:SetCheckAlignment(alignML);
		oP.kinship:SetText(spaces..WCFLangData.kinship);
		oP.kinship.CheckedChanged = function(box)
			settings.kinship = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	-- Craft --
	top = add_h_line(top);
	if (not oP.craft) then	
		oP.craft = UIcheckbox();
		oP.craft:SetParent(oP);
		oP.craft:SetSize(width, 16);
		oP.craft:SetPosition(left, top);
		oP.craft:SetFont(font);
		oP.craft:SetCheckAlignment(alignML);
		oP.craft:SetText(spaces..WCFLangData.craft);
		oP.craft.CheckedChanged = function(box)
			settings.craft = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	-- Help --
	top = add_h_line(top);
	if (not oP.chelp) then	
		oP.chelp = UIcheckbox();
		oP.chelp:SetParent(oP);
		oP.chelp:SetSize(width, 16);
		oP.chelp:SetPosition(left, top);
		oP.chelp:SetFont(font);
		oP.chelp:SetCheckAlignment(alignML);
		oP.chelp:SetText(spaces..WCFLangData.chelp);
		oP.chelp.CheckedChanged = function(box)
			settings.chelp = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	-- Monsterplay --
	top = add_h_line(top);
	if (not oP.mp) then	
		oP.mp = UIcheckbox();
		oP.mp:SetParent(oP);
		oP.mp:SetSize(width, 16);
		oP.mp:SetPosition(left, top);
		oP.mp:SetFont(font);
		oP.mp:SetCheckAlignment(alignML);
		oP.mp:SetText(spaces..WCFLangData.mptxt);
		oP.mp.CheckedChanged = function(box)
			settings.mp = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	-- Links --
	top = add_h_line(top);
	if (not oP.links) then	
		oP.links = UIcheckbox();
		oP.links:SetParent(oP);
		oP.links:SetSize(width, 16);
		oP.links:SetPosition(left, top);
		oP.links:SetFont(font);
		oP.links:SetCheckAlignment(alignML);
		oP.links:SetText(spaces..WCFLangData.links);
		oP.links.CheckedChanged = function(box)
			settings.links = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	-- Hi and Goodby --
	top = add_h_line(top);
	if (not oP.higb) then	
		oP.higb = UIcheckbox();
		oP.higb:SetParent(oP);
		oP.higb:SetSize(width, 16);
		oP.higb:SetPosition(left, top);
		oP.higb:SetFont(font);
		oP.higb:SetCheckAlignment(alignML);
		oP.higb:SetText(spaces..WCFLangData.higb);
		oP.higb.CheckedChanged = function(box)
			settings.higb = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end

	--## Userdefined Filters ##--
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(0, top - 3);
	label:SetSize(width + 20, 30);
	label:SetBackColor(color(0.1, 0.1, 0.3));
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top + 3);
	label:SetSize(width, 18);
	label:SetFont(font);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.udflabel);
	label:SetTextAlignment(alignMC);
	-- Exclude Filter --
	top = add_h_line(top,true);
	if (not oP.exfilter) then	
		oP.exfilter = UIcheckbox();
		oP.exfilter:SetParent(oP);
		oP.exfilter:SetSize(width, 24);
		oP.exfilter:SetPosition(left, top + 1);
		oP.exfilter:SetFont(font);
		oP.exfilter:SetCheckAlignment(alignML);
		oP.exfilter:SetTextAlignment(alignTL);
		oP.exfilter:SetText(spaces..WCFLangData.exftxt.."\n"..spaces..WCFLangData.fhinttxt);
		oP.exfilter.CheckedChanged = function(box)
			settings.exfilter = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	top = add_h_line(top + 8);
	if (not oP.exfpattern) then
		oP.exfpattern = UItextbox();
		oP.exfpattern:SetSelectable();
		oP.exfpattern:SetEnabled();
		oP.exfpattern:SetParent(oP);
		oP.exfpattern:SetSize(width, 18);
		oP.exfpattern:SetPosition(left, top + 2);
		oP.exfpattern:SetMultiline(false);
		oP.exfpattern:SetFont(fontb);
		oP.exfpattern:SetTextAlignment(alignLC);
		oP.exfpattern:SetBackColor(color(0.1, 0.1, 0.1));
		oP.exfpattern:SetText("");
		oP.exfpattern.TextChanged = function(textbox)
			settings.exfpattern = textbox:GetText();
			DoCallbacks(oP, SChng);
		end
	end
	-- Include Filter --
	top = add_h_line(top,true);
	if (not oP.infilter) then	
		oP.infilter = UIcheckbox();
		oP.infilter:SetParent(oP);
		oP.infilter:SetSize(width, 24);
		oP.infilter:SetPosition(left, top + 1);
		oP.infilter:SetFont(font);
		oP.infilter:SetCheckAlignment(alignML);
		oP.infilter:SetTextAlignment(alignTL);
		oP.infilter:SetText(spaces..WCFLangData.inftxt.."\n"..spaces..WCFLangData.fhinttxt);
		oP.infilter.CheckedChanged = function(box)
			settings.infilter = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	top = add_h_line(top + 8);
	if (not oP.infpattern) then
		oP.infpattern = UItextbox();
		oP.infpattern:SetSelectable();
		oP.infpattern:SetEnabled();
		oP.infpattern:SetParent(oP);
		oP.infpattern:SetSize(width, 18);
		oP.infpattern:SetPosition(left, top + 2);
		oP.infpattern:SetMultiline(false);
		oP.infpattern:SetFont(fontb);
		oP.infpattern:SetTextAlignment(alignLC);
		oP.infpattern:SetBackColor(color(0.1, 0.1, 0.1));
		oP.infpattern:SetText("");
		oP.infpattern.TextChanged = function(textbox)
			settings.infpattern = textbox:GetText();
			DoCallbacks(oP, SChng);
		end
	end

	--## Player-Blacklist ##--
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(0, top - 3);
	label:SetSize(width + 20, 30);
	label:SetBackColor(color(0.1, 0.1, 0.3));
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top + 3);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.pbllabel);
	label:SetTextAlignment(alignMC);
	top = add_h_line(top,true);
	if (not oP.blstate) then	
		oP.blstate = UIcheckbox();
		oP.blstate:SetParent(oP);
		oP.blstate:SetSize(width, 16);
		oP.blstate:SetPosition(left, top + 1);
		oP.blstate:SetFont(font);
		oP.blstate:SetCheckAlignment(alignML);
		oP.blstate:SetText(spaces..WCFLangData.pbltxt);
		oP.blstate.CheckedChanged = function(box)
			settings.blstate = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	top = add_h_line(top);
	if (not oP.blacklist) then
		oP.blacklist = UItextbox();
		oP.blacklist:SetSelectable();
		oP.blacklist:SetEnabled();
		oP.blacklist:SetParent(oP);
		oP.blacklist:SetSize(width, 18);
		oP.blacklist:SetPosition(left, top + 2);
		oP.blacklist:SetMultiline(false);
		oP.blacklist:SetFont(fontb);
		oP.blacklist:SetTextAlignment(alignLC);
		oP.blacklist:SetBackColor(color(0.1, 0.1, 0.1));
		oP.blacklist:SetText("");
		oP.blacklist.TextChanged = function(textbox)
			settings.blacklist = textbox:GetText();
			DoCallbacks(oP, SChng);
		end
	end

	--## Player-Whitelist ##--
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(0, top - 3);
	label:SetSize(width + 20, 30);
	label:SetBackColor(color(0.1, 0.1, 0.3));
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top + 3);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.pwllabel);
	label:SetTextAlignment(alignMC);
	top = add_h_line(top,true);
	if (not oP.wlstate) then	
		oP.wlstate = UIcheckbox();
		oP.wlstate:SetParent(oP);
		oP.wlstate:SetSize(width, 16);
		oP.wlstate:SetPosition(left, top + 1);
		oP.wlstate:SetFont(font);
		oP.wlstate:SetCheckAlignment(alignML);
		oP.wlstate:SetText(spaces..WCFLangData.pwltxt);
		oP.wlstate.CheckedChanged = function(box)
			settings.wlstate = box:IsChecked();
			DoCallbacks(oP, SChng);
		end
	end
	top = add_h_line(top);
	if (not oP.whitelist) then
		oP.whitelist = UItextbox();
		oP.whitelist:SetSelectable();
		oP.whitelist:SetEnabled();
		oP.whitelist:SetParent(oP);
		oP.whitelist:SetSize(width, 18);
		oP.whitelist:SetPosition(left, top + 2);
		oP.whitelist:SetMultiline(false);
		oP.whitelist:SetFont(fontb);
		oP.whitelist:SetTextAlignment(alignLC);
		oP.whitelist:SetBackColor(color(0.1, 0.1, 0.1));
		oP.whitelist:SetText("");
		oP.whitelist.TextChanged = function(textbox)
			settings.whitelist = textbox:GetText();
			DoCallbacks(oP, SChng);
		end
	end

	--## Changepattern language ##--
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(0, top - 3);
	label:SetSize(width + 20, 30);
	label:SetBackColor(color(0.1, 0.1, 0.3));
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top + 3);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.pllabel);
	label:SetTextAlignment(alignMC);
	top = add_h_line(top,true);
	if (not oP.sbar) then
		oP.sbar = UILscrollbar();
		oP.sbar:SetEnabled();
		oP.sbar:SetVisible(false);
		oP.sbar:SetParent(oP);
		oP.sbar:SetWidth(10);
		oP.sbar:SetPosition(left, top + 1);
		oP.sbar:SetHeight(20);
		oP.sbar:SetBackColor(color(0.3, 0.3, 0.3));
		oP.sbar:SetOpacity(0.0);
		oP.sbar:SetBlendMode(0);
		oP.sbar:SetBackColorBlendMode(0);
		oP.sbar:SetValue(1);
		oP.sbar:SetMinimum(1);
		oP.sbar:SetMaximum(3);
		oP.sbar:SetOrientation(UIOvert);
		oP.sbar.ValueChanged = function(ScrollBar)
			local tmp = ScrollBar:GetValue();
			if not (settings.plng == tmp) then
				settings.plng = tmp
				local plng = select(settings.plng,WCFLangData.pdetxt,WCFLangData.pentxt,WCFLangData.pfrtxt)
				oP.plang:SetText(plng);
				write(wcol1..WCFLangData.pchng.." => "..plng..wcol0);
				DoCallbacks(oP, SChng);
			end;
		end
	end
	if (not oP.plang) then
		oP.plang = UILtextbox();
		oP.plang:SetParent(oP);
		oP.plang:SetSize(width - 12, 20);
		oP.plang:SetPosition(left + 12, top + 2);
		oP.plang:SetFont(fontsb);
		oP.plang:SetReadOnly(true)
		oP.plang:SetTextAlignment(alignMC);
		oP.plang:SetBackColor(color(0.3, 0.3, 0.3));
		oP.plang:SetForeColor(color(0.4, 1, 1));
		oP.plang:SetText("");
	end

	--## Button reset to Defaults ##--
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(0, top - 3);
	label:SetSize(width + 20, 30);
	label:SetBackColor(color(0.1, 0.1, 0.3));
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top + 3);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.rsetlabel);
	label:SetTextAlignment(alignMC);
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(0, top - 3);
	label:SetSize(width + 20, 30);
	label:SetBackColor(color(0.1, 0.1, 0.3));
	oP.resetButton = UILGbutton();
	oP.resetButton:SetParent(oP);
	oP.resetButton:SetText(WCFLangData.reset);
	oP.resetButton:SetSize(width,20);
	oP.resetButton:SetPosition(left + 22, top + 1);
	oP.resetButton:SetForeColor(color(0.6, 0.6, 0.9));
	oP.resetButton.Click = function()
		DeepTableCopy(defaultSettings, settings);
		UpdateOPStates(false);
		write(wcol1..WCFLangData.drtxt..wcol0);
		DoCallbacks(oP, SChng);
	end;

	--## Server-wide Defaults ##--
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(0, top - 3);
	label:SetSize(width + 20, 30);
	label:SetBackColor(color(0.1, 0.1, 0.3));
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(left, top + 3);
	label:SetSize(width, 18);
	label:SetFont(fontb);
	label:SetBackColor(color(0.2, 0.2, 1));
	label:SetForeColor(color(0, 1, 0));
	label:SetText(WCFLangData.swdlabel);
	label:SetTextAlignment(alignMC);
	-- Load Button --
	top = add_h_line(top,true);
	label = UIlabel();
	label:SetParent(oP);
	label:SetPosition(0, top - 3);
	label:SetSize(width + 20, 30);
	label:SetBackColor(color(0.1, 0.1, 0.3));
	local bwidth, bleft = (width / 2) - 4, left + (width / 2) + 4;
	oP.loadButton, oP.saveButton = UILbutton(), UILbutton();
	oP.loadButton:SetParent(oP);
	oP.loadButton:SetText(WCFLangData.swdload);
	oP.loadButton:SetEnabled(false);
	oP.loadButton:SetWidth(bwidth);
	oP.loadButton:SetPosition(left, top + 2);
	oP.loadButton.Click = function()
		LoadSettings(true,true,false);
		write(wcol1..WCFLangData.spload..wcol0);
	end;
	if (sset == 1) then oP.loadButton:SetEnabled(true); end;
	-- Save Button --
	oP.saveButton:SetParent(oP);
	oP.saveButton:SetText(WCFLangData.swdsave);
	oP.saveButton:SetWidth(bwidth);
	oP.saveButton:SetPosition(bleft, top + 2);
	oP.saveButton.Click = function()
		SaveSettings(true,true);
		oP.loadButton:SetEnabled(true);
		write(wcol1..WCFLangData.spsave..wcol0);
	end;
	top = (top + oP.saveButton:GetHeight()) + 10;
	-- draw buttom line
	line = UIControl();
	line:SetParent(oP);
	line:SetPosition(0, top -3);
	line:SetSize(width + (left * 2), 3);
	line:SetBackColor(color(41/255, 48/255, 72/255));
	line:SetZOrder(52);
	-- set height
	oP.lline:SetHeight(top);
	oP.rline:SetHeight(top);
	oP.backg:SetHeight(top);
	oP:SetSize(width + 8, top);
	UpdateOPStates(false);
end

--## Adds an quickslot-icon for WCFilter ##--
function GetOptWindow()
	WCFWin = Turbine.UI.Window();
	WCFWin.WasDrag = false;
	WCFWin:SetSize(20, 21);
	WCFWin:SetZOrder(9198);
	local screenWidth, screenHeight = Turbine.UI.Display.GetSize()
	local winWidth, winHeight = WCFWin:GetSize();
	-- if not set then sets default and save
	if settings.locX == nil then
		settings.locX, settings.locY = 60, screenHeight - winHeight - 40
		SaveSettings(true, false);
	end
	--Replace if out of screenwidth/screenheight
	if settings.locX + winWidth > screenWidth then ResetLoc(); end
	if settings.locY + winHeight > screenHeight then ResetLoc(); end
	WCFWin:SetPosition(settings.locX, settings.locY);
	WCFWin:SetVisible(true);
	WCFWin:SetOpacity(0.6);

	optButton = Turbine.UI.Button();
	optButton:SetParent(WCFWin);
	optButton:SetPosition(0, 0);
	optButton:SetSize(WCFWin:GetWidth(), WCFWin:GetHeight());
	optButton:SetBackground(logo);
	optButton.MouseEnter = function() WCFWin:SetOpacity(1.0); end;
	optButton.MouseLeave = function() WCFWin:SetOpacity(0.6); end;
	optButton.MouseDown = function(sender, args)
		WCFWin.dragStartX, WCFWin.dragStartY = args.X, args.Y;
		WCFWin.dragging = true;
	end
	optButton.MouseUp = function(sender, args)
		local screenWidth, screenHeight = Turbine.UI.Display.GetSize();
		if WCFWin:GetLeft() < 0 then WCFWin:SetLeft(0); end
		if WCFWin:GetLeft() + WCFWin:GetWidth() > screenWidth then WCFWin:SetLeft(screenWidth - WCFWin:GetWidth()); end
		if WCFWin:GetTop() < 0 then WCFWin:SetTop(0); end
		if WCFWin:GetTop() + WCFWin:GetHeight() > screenHeight then WCFWin:SetTop(screenHeight - WCFWin:GetHeight()); end
		WCFWin.dragging = false;
		settings.locX, settings.locY = WCFWin:GetPosition();
		SaveSettings(true, false);
	end
	optButton.MouseMove = function(sender, args)
		local left, top = WCFWin:GetPosition();
		if WCFWin.dragging then
			WCFWin:SetPosition(left + (args.X - WCFWin.dragStartX), top + (args.Y - WCFWin.dragStartY));
			WCFWin.WasDrag = true;
		end
	end
----
	WCFMenu = Turbine.UI.ContextMenu();
	menuItems = WCFMenu:GetItems();
	menuItems:Add(Turbine.UI.MenuItem(" WCFilter v"..version.." ",false));
	menuItems:Add(Turbine.UI.MenuItem("= by Burgus ====",false));
	menuItems:Add(Turbine.UI.MenuItem("Reload"));
	menuItems:Add(Turbine.UI.MenuItem("Unload"));
	--menuItems:Add(Turbine.UI.MenuItem("Option 3"));
	--menuItems:Add(Turbine.UI.MenuItem("Option 4"));
	menuItems:Add(Turbine.UI.MenuItem("=================",false));
	optButton.MouseClick = function(sender, args)
		if args.Button == Turbine.UI.MouseButton.Right then
			WCFMenu:ShowMenu();
		else
			if not WCFWin.WasDrag then Turbine.PluginManager.ShowOptions(Plugins["WCFilter"]); end
			WCFWin.WasDrag = false;
		end;
	end;
	local i;
	for i = 1, menuItems:GetCount() do
		local menuItem = menuItems:Get(i);
		if menuItem.IsEnabled then
			function menuItem.Click(sender,args)
				if sender:GetText() == "Reload" then
					local importPath = getfenv(1)._.Name;
						Turbine.PluginManager.UnloadScriptState( 'WCFilterReloader' );
						Turbine.PluginManager.LoadPlugin( 'WCFilter Reloader' );
				elseif sender:GetText() == "Unload" then
						Turbine.PluginManager.LoadPlugin( 'WCFilter Unloader' );					
				--else
					--Turbine.Shell.WriteLine("You have selected "..sender:GetText()..".");
				end
			end
		end
	end
----
end

function ResetLoc()
	local screenWidth, screenHeight = Turbine.UI.Display.GetSize();
	local winWidth, winHeight = WCFWin:GetSize();
	settings.locX, settings.locY = 60, screenHeight - winHeight - 40;
	WCFWin:SetPosition(settings.locX, settings.locY);
	SaveSettings(true, false);
end

--## HelpWindow ##--
function GetHelpWindow()
	local screenWidth, screenHeight = Turbine.UI.Display.GetSize();
	local winWidth, winHeight = 800, WCFLangData.HelpWinSize;
	--change size and position if not fit to the screen
	local winXPos, winYPos = (screenWidth - winWidth)/2, (screenHeight - winHeight)/2;
	if winWidth > screenWidth then winWidth = screenWidth - 10; end;
	if winHeight > screenHeight then winHeight = screenHeight - 10; end;
	if (screenHeight - winHeight) > 80 then winYPos = winYPos - 80; end;
	--define window
	WCFHWin = Turbine.UI.Lotro.Window();
	WCFHWin:SetSize(winWidth, winHeight);
	WCFHWin:SetPosition(winXPos, winYPos);
	WCFHWin:SetZOrder(9199);
	WCFHWin:SetText(WCFLangData.HelpLabel);
	WCFHWin:SetVisible(true);
	WCFHWin:SetOpacity(0.7);
	WCFHWin:Focus();
	WCFHWin.KeyDown = function(sender, args)
		if (args.Action == Turbine.UI.Lotro.Action.Escape) or (args.Action == 268435635) then WCFHWin:Close(); end;
	end;
	WCFHWin.MouseEnter = function() WCFHWin:SetOpacity(1.0); end;
	WCFHWin.MouseLeave = function() WCFHWin:SetOpacity(0.7); end;
	WCFHWin:SetWantsKeyEvents(true);
	--Scrollbar for textbox
	local tbWidth, tbHeight = winWidth - 60, winHeight - 82;
	tBoxSlBar = UILscrollbar();
	tBoxSlBar:SetOrientation(UIOvert);
	tBoxSlBar:SetPosition(tbWidth - 4, 0);
	tBoxSlBar:SetSize(4, tbHeight);
	tBoxSlBar:SetValue(0);
	tBoxSlBar:SetVisible(true);
	--Textbox
	tBox = UItextbox();
	tBox:SetParent(WCFHWin);
	tBox:SetMarkupEnabled(true);
	tBox:SetEnabled(false);
	tBox:SetSelectable(true);
	tBox:SetMultiline(true);
	tBox:SetPosition(30, 40);
	tBox:SetSize(tbWidth, tbHeight - 5);
	tBox:SetVerticalScrollBar(tBoxSlBar);
	tBox:SetText(WCFLangData.HelpWinTxt);
	tBox:SetTextAlignment(alignTL);
	--workaround for turbine bug (SetParent) with scrollbars
	tBoxSlBar:SetParent(tBox);
	tBoxSlBar:SetEnabled(true);
	--Close button
	local closeButton = UILbutton();
	closeButton:SetParent(WCFHWin);
	closeButton:SetText(WCFLangData.HelpWinCB);
	closeButton:SetSize(100, 20);
	closeButton:SetPosition((winWidth - 100)/2, tbHeight + 46);
	closeButton.Click = function()
		WCFHWin:Close();
	end;
end
